using System;

namespace Elephant.Framework
{
    /// <summary>
    /// Represents the EventArgs that are passed along when an event involving a component is raised.
    /// </summary>
    public class EntityComponentEventArgs : EventArgs
    {
        EntityComponent component;

        public EntityComponentEventArgs(EntityComponent component)
        {
            this.component = component;
        }

        public EntityComponent Component
        {
            get
            {
                return component;
            }
        }
    }
}
