using System;

namespace Elephant.Framework
{
    /// <summary>
    /// Represents the EventArgs that are passed along when a component is removed.
    /// </summary>
    public class EntityComponentRemovedEventArgs : EntityComponentEventArgs
    {
        bool updateDependencies;

        public EntityComponentRemovedEventArgs(EntityComponent component, bool updateDependencies)
            : base(component)
        {
            this.updateDependencies = updateDependencies;
        }

        public bool UpdateDependencies
        {
            get
            {
                return updateDependencies;
            }
        }
    }
}
